// Benday.NamedPipesSample.Win32ConsoleApp.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "Benday.NamedPipesSample.Win32ConsoleApp.h"
#include "conio.h"
#include <iostream>
#include <string>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// The one and only application object

CWinApp theApp;

using namespace std;

void RunClient()
{
	HANDLE hFileNamedPipe;
	BOOL flg;
	DWORD dwWrite;
	char szMessageToWriteToPipe[200];

	// this is the name of the pipe
	LPCWSTR nameOfPipe = L"\\\\.\\pipe\\NamedPipeTest";
	
	// create the pipe
	hFileNamedPipe = CreateFile(nameOfPipe, GENERIC_WRITE, 
		0, NULL, OPEN_EXISTING,
		0, NULL);

	strcpy_s(szMessageToWriteToPipe, "Data from Named Pipe client for createnamedpipe");
	if(hFileNamedPipe == INVALID_HANDLE_VALUE)
	{ 
		printf("CreateFile failed for Named Pipe client\n" );
	}
	else
	{
		string message;

		// while the message isn't "exit", keep writing lines to the server
		while (message != "exit")
		{
			printf("Type message to server ('exit' to quit): ");
			getline(cin, message, '\n');
		
			if (message != "exit")
			{
				// copy the message from the command line to something that's writeable to the pipe stream
				strcpy_s(szMessageToWriteToPipe, message.c_str());

				// write the message to the pipe
				flg = WriteFile(hFileNamedPipe, szMessageToWriteToPipe, strlen(szMessageToWriteToPipe), &dwWrite, NULL);

				if (FALSE == flg)
				{
					printf("WriteFile failed for Named Pipe client\n");
				}
				else
				{
					printf("WriteFile succeeded for Named Pipe client\n");
				}
			}
		}

		CloseHandle(hFileNamedPipe);
	}
}

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		_tprintf(_T("Fatal Error: MFC initialization failed\n"));
		nRetCode = 1;
	}
	else
	{
		printf("Make sure that the server is started then press any key to run client...\n");
        // Wait for a key press.
        int iKeyPress = _getch();
		
		RunClient();

		printf("Press any key to continue...\n");
        // Wait for a key press.
        iKeyPress = _getch();
	}

	return nRetCode;
}
